from config import FILENAME

print(" -------------------------------------------------------------------------- ")
print("File: ", FILENAME)
print(" -------------------------------------------------------------------------- ")

with open("input/" + FILENAME) as file:
    content = file.readlines()

port_count = int(content[0].split(" ")[1])
node_count = int(content[1].split(" ")[1])
vessel_count = int(content[2].split(" ")[1])
voyage_count = int(content[3].split(" ")[1])
contract_count = int(content[4].split(" ")[1])
end_of_planning_horizon = int(content[5].split(" ")[1])
product_count = int(content[6].split(" ")[1])
velocities_count = int(content[7].split(" ")[1])

vessel_capacity = {}
vessel_origin = {}
vessel_available_at = {}

sailing_time = {}
charter_cost = {}
sailing_cost = {}
distance_in = {}
contract_demand = {}
contract_ports = {}
contract_transit_time = {}
maximum_quantity = {}
minimum_quantity = {}
minimum_pickups = {}
maximum_pickups = {}
evenly_spread_contracts = []
port_cost = {}
port_costs = {}
handling_times = {}
node_time = {}

first_port = vessel_count + 1
last_port = vessel_count + port_count
last_node = 2 * vessel_count + port_count

vessels = [i for i in range(1, vessel_count+1)]

origin = {}
destination = {}
for k in vessels:
    origin[k] = k
    destination[k] = vessel_count + port_count + k

for x in range(8, len(content)):
    line = content[x].split(" ")[0]

    if line == "VesselOrigin:":
        for y in range(1, vessel_count+1):
            vessel_origin[y] = int(content[x+y].strip("\t \n )"))

    elif line == "DistanceIn:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split(" ")
                distance_in[int(line_content[1]), int(line_content[2])] = float(line_content[3].strip("\t \n )"))


    elif line == "VesselCapacity:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split(" ")
                vessel_capacity[int(line_content[2]), int(line_content[1])] = float(line_content[3].strip("\t \n )"))

    # TODO: vessel_available_at = []
    elif line == "VesselAvailableAt:":
        for y in range(1, vessel_count + 1):
            vessel_available_at[(int(content[x + y].split(" ")[1]))] = float(content[x + y].split(" ")[2].strip("\t \n )"))
    # TODO: Her -----
    elif line == "SailingTime:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split(" ")
                sailing_time[int(line_content[1]), int(line_content[2])] = float(line_content[3].strip("\t \n )"))


    # TODO: charter_cost = []
    elif line == "CharterCost:":
        for y in range(1, vessel_count + 1):
            charter_cost[y] = float(content[x + y].strip("\t \n )"))

    elif line == "SailingCost:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split(" ")
                sailing_cost[int(line_content[1]), int(line_content[2])] = (float(line_content[3].strip("\t \n )")))
                for key, value in distance_in.items():
                    (i,j) = key
                    #sailing_cost[i, j, int(line_content[1]), int(line_content[2])] = (float(line_content[3].strip("\t \n )")))*value

    # TODO: contract_demand = np.array([[0] * vessel_count] * product_count)
    elif line == "ContractDemand:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split(" ")
                contract_demand[int(line_content[1]), int(line_content[2])] = float(line_content[3].strip("\t \n )"))

    # TODO: contract_ports = np.array([[0] * vessel_count] * product_count)
    elif line == "ContractPorts:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split("\t")
                contract_ports[y-x] = (int(line_content[1]), int(line_content[2]))

    # TODO: contract_transit_time = []
    elif line == "ContractTransitTime:":
        for y in range(1, contract_count + 1):
            contract_transit_time[y] = float(content[x + y].strip("\t \n )"))

    # TODO: maximum_quantity = np.array([[0] * vessel_count] * product_count)
    elif line == "MaximumQuantity:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split(" ")
                maximum_quantity[int(line_content[1]), int(line_content[2])] = float(line_content[3].strip("\t \n )"))

    # TODO: minimum_quantity = np.array([[0] * vessel_count] * product_count)
    elif line == "MinimumQuantity:":
        unfinished = True
        y = x

        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                line_content = content[y].split(" ")
                minimum_quantity[int(line_content[1]), int(line_content[2])] = float(line_content[3].strip("\t \n )"))

    # TODO: minimum_pickups = []
    elif line == "MinimumPickups:":
        for y in range(1, contract_count + 1):
            minimum_pickups[y] = int(content[x + y].strip("\t \n )"))

    # TODO: maximum_pickups = []
    elif line == "MaximumPickups:":
        for y in range(1, contract_count + 1):
            maximum_pickups[y] = int(content[x + y].strip("\t \n )"))

    # TODO: evenly_spread_contracts = []
    elif line == "EvenlySpreadContracts:":
        unfinished = True
        y = x
        while unfinished:
            y += 1
            if "]" in content[y]:
                unfinished = False
            else:
                evenly_spread_contracts.append(int(content[y].strip("\t \n )")))

    # TODO: port_costs = [] - sjekk
    elif line == "PortCosts:":
        for y in range(1, port_count + 1):
            port_cost[int(content[x + y].split(" ")[1])] = float(content[x + y].split(" ")[2].strip("\t \n )"))


    # TODO: handling_times = []
    elif line == "HandlingTime:":
        for y in range(1, product_count + 1):
            handling_times[int(content[x + y].split(" ")[1])] = float(content[x + y].split(" ")[3].strip("\t \n )"))

    # TODO: node_time = []
    elif line == "NodeTime:":
        for y in range(1, port_count + 1):
            node_time[int(content[x + y].split(" ")[1])] = float(content[x + y].split(" ")[2].strip("\t \n )"))
